{% extends 'base.html' %}
{% load custom_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span></a>
    </li>
{% endblock %}
{% block extra-head %}
    <script src="https://kit.fontawesome.com/a076d05399.js"></script>
{% endblock %}
{% block content %}

    <div style="margin: 3%;">

        <div class="h3 mt-3 text-center ">
            <h1 class="text-light"> Tablero Kanban</h1>
        </div>
        <a class="btn btn-light m-1 btn btn-outline-dark "
           href="{% if volver == 0 %} {% url 'Proyecto:index' %} {% else %} {% url 'Proyecto:ListarSprint'  proyecto.id %} {% endif %}"
           role="button">Volver</a>
        <div class="row flex-row flex-sm-nowrap py-3 p-1 m-1" style="width: 100%">

            <div class="col-sm-6 col-md-4 col-xl-3 m-1 p-0 border border-ligth rounded">
                <div id="divPendienteCards" class="card card-border-primary bg-primary" {% if modificable %}
                     ondrop="drop(event)"
                    ondragover="allowDrop(event) {% endif %}">
                    <div id="divPendiente" class="card-header">
                        <h5 class="card-title text-light" style="text-align:center;"><b>Pendiente</b></h5>
                        <h6 class="card-subtitle text-light" style="text-align:center;"><b>Lista de US que aun no se han empezado.</b></h6>
                    </div>
                    {% for x in planningPokers %}
                        {% if x.estado == "P" %}
                            <!--condicion para que un miembro a quien no le corresponde la us no pueda arrastrar la tarjeta por el kanban-->
                            <div id="{{ x.id }}" class="card-body p-3"
                                    {% if proyecto.estado != 'T' %}
                                        {% if sprint.estado == 'E' %}
                                            {% if  x.miembroEncargado.idUser.username == user.get_username or x.idSprint.idProyecto.scrumMaster.username == user.get_username %}
                                 draggable="true" ondragstart="drag(event)"
                                            {% endif %}{% endif %}}{% endif %}>

                                <div class="card mb-3 bg-light">
                                    <h3 class="card-header text-center">{{ x.idUs.titulo }}</h3>
                                    <div class="card-body p-3">
                                        <p class="card-text"><b>Descripción</b>: {{ x.idUs.descripcion }}</p>
                                        <p class="card-text"><b>Encargado</b>: {{ x.miembroEncargado.idUser.first_name }} {{ x.miembroEncargado.idUser.last_name }}
                                        <p class="card-text"> {{ x.miembroEncargado.idUser.email }}
                                        </p>
                                    </div>
                                    <div class="card-button p-2">
                                        <!--si es scrum master no cuenta como miembro, por lo tanto no puede agregar actividades a las us, evita tambien errores-->
                                        <a class="btn btn-outline-primary"
                                           href="{% url 'Proyecto:historialUs' x.idSprint.idProyecto.id x.idUs.id 0 volver x.idSprint.id %}"
                                           role="button">Ver historial</a>
                                        <!--idProyecto, idSPrint, idUs-->

                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    {% endfor %}
                </div>
            </div>

            <div class="col-sm-6 col-md-4 col-xl-3 border border-ligth rounded m-1 p-0">
                <div id="divProcesoCards" class="card card-border-primary bg-info" {% if modificable %}
                     ondrop="drop(event)"
                    ondragover="allowDrop(event) {% endif %}">
                    <div id="divProceso" class="card-header ">
                        <h5 class="card-title text-light" style="text-align:center;"><b>En proceso</b></h5>
                        <h6 class="card-subtitle text-light" style="text-align:center;"><b>Lista de US que ya se han empezado.</b></h6>
                    </div>
                    {% for x in planningPokers %}
                        {% if x.estado == "EP" %}
                            <div id="{{ x.id }}" class="card-body p-3"
                                    {% if proyecto.estado != 'T' %}
                                        {% if sprint.estado == 'E' %}
                                            {% if  x.miembroEncargado.idUser.username == user.get_username or x.idSprint.idProyecto.scrumMaster.username == user.get_username %}
                                 draggable="true" ondragstart="drag(event)"
                                            {% endif %}{% endif %}{% endif %}>

                                <div class="card mb-3 bg-light">
                                    <h3 class="card-header text-center">{{ x.idUs.titulo }}</h3>
                                    <div class="card-body p-3">
                                        <p class="card-text"><b>Descripción</b>: {{ x.idUs.descripcion }}</p>
                                        <p class="card-text"><b>Encargado</b>: {{ x.miembroEncargado.idUser.first_name }} {{ x.miembroEncargado.idUser.last_name }}
                                        <p class="card-text"> {{ x.miembroEncargado.idUser.email }}
                                        </p>
                                    </div>
                                    <div class="card-button p-2">
                                        {% if not esScrumMaster %}
                                            {% if x.miembroEncargado.idUser.username == user.get_username or x.idSprint.idProyecto.scrumMaster.username == user.get_username %}
                                                <a class="btn btn-outline-info"
                                                   href="{% url 'Proyecto:agregarActividad' x.idSprint.idProyecto.id x.idSprint.id x.idUs.id volver %}"
                                                   role="button">Agregar actividad</a>
                                            {% endif %}
                                        {% endif %}
                                        <a class="btn btn-outline-info"
                                           href="{% url 'Proyecto:historialUs' x.idSprint.idProyecto.id x.idUs.id 0 volver x.idSprint.id %}"
                                           role="button">Ver historial</a>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    {% endfor %}
                </div>
            </div>

            <div class="col-sm-6 col-md-4 col-xl-3 border border-ligth rounded m-1 p-0">
                <div id="divHechoCards" class="card card-border-primary bg-success" {% if modificable %}
                     ondrop="drop(event)"
                    ondragover="allowDrop(event) {% endif %}">
                    <div id="divHecho" class="card-header">
                        <h5 class="card-title text-light" style="text-align:center;"><b>Hecho</b></h5>
                        <h6 class="card-subtitle text-light" style="text-align:center;"><b>Lista de US que ya estan terminadas y pendientes
                            de aprobación.</b></h6>
                    </div>
                    {% for x in planningPokers %}
                        {% if x.estado == "H" %}
                            <div id="{{ x.id }}" class="card-body p-3"
                                    {% if proyecto.estado != 'T' %}
                                        {% if sprint.estado == 'E' %}
                                            {% if  x.miembroEncargado.idUser.username == user.get_username or x.idSprint.idProyecto.scrumMaster.username == user.get_username %}
                                 draggable="true" ondragstart="drag(event)"
                                            {% endif %}
                                        {% endif %}
                                    {% endif %}>

                                <div class="card mb-3 bg-light">
                                    <h3 class="card-header text-center">{{ x.idUs.titulo }}</h3>
                                    <div class="card-body p-3">
                                        <p class="card-text"><b>Descripción</b>: {{ x.idUs.descripcion }}</p>
                                        <p class="card-text"><b>Encargado</b>: {{ x.miembroEncargado.idUser.first_name }} {{ x.miembroEncargado.idUser.last_name }}
                                        <p class="card-text"> {{ x.miembroEncargado.idUser.email }}
                                        </p>
                                    </div>
                                    <div class="card-button p-2">
                                        <!--en este caso al scrum se le mostrara esta opcion ya que debe registrar su aprobacion o no de la US, problemas con el idMiembro-->
                                        {% if esScrumMaster %}
                                            <!--del mismo modo, no deja que un miembro a quien le corresponde la us pueda agregar actividades-->
                                            {% if  x.miembroEncargado.idUser.username == user.get_username or x.idSprint.idProyecto.scrumMaster.username == user.get_username %}
                                                <a class="btn btn-outline-success"
                                                   href="{% url 'Proyecto:agregarActividad' x.idSprint.idProyecto.id x.idSprint.id x.idUs.id volver %}"
                                                   role="button">Agregar actividad</a>
                                            {% endif %}
                                        {% endif %}
                                        <a class="btn btn-outline-success"
                                           href="{% url 'Proyecto:historialUs' x.idSprint.idProyecto.id x.idUs.id 0 volver x.idSprint.id %}"
                                           role="button">Ver historial</a>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    {% endfor %}
                </div>
            </div>

            <div class="col-sm-6 col-md-4 col-xl-3 border border-ligth rounded m-1 p-0" {% if  not esScrumMaster %}
                 style="display: none;" {% endif %}>
                <div id="divAprobadoCards" class="card card-border-primary bg-secondary" {% if modificable %}
                     ondrop="drop(event)"
                    ondragover="allowDrop(event) {% endif %}">
                    <div id="divAprobado" class="card-header">
                        <h5 class="card-title text-light" style="text-align:center;"><b>Aprobados</b></h5>
                        <h6 class="card-subtitle text-light" style="text-align:center;"><b>Lista de US que ya han sido terminadas y estan
                            aprobadas.</b></h6>
                    </div>
                    {% for x in planningPokers %}
                        {% if x.estado == "A" %}
                            <div id="{{ x.id }}" class="card-body p-3"
                                    {% if proyecto.estado != 'T' %}
                                        {% if sprint.estado == 'E' %}
                                            {% if  x.miembroEncargado.idUser.username == user.get_username or x.idSprint.idProyecto.scrumMaster.username == user.get_username %}
                                 draggable="true" ondragstart="drag(event)"
                                            {% endif %}
                                        {% endif %}
                                    {% endif %}>

                                <div class="card mb-3 bg-light">
                                    <h3 class="card-header text-center">{{ x.idUs.titulo }}</h3>
                                    <div class="card-body p-3">
                                        <p class="card-text"><b>Descripción</b>: {{ x.idUs.descripcion }}</p>
                                        <p class="card-text"><b>Encargado</b>: {{ x.miembroEncargado.idUser.first_name }} {{ x.miembroEncargado.idUser.last_name }}
                                        <p class="card-text"> {{ x.miembroEncargado.idUser.email }}
                                        </p>
                                    </div>
                                    <div class="card-button p-2">
                                        <a class="btn btn-outline-secondary"
                                           href="{% url 'Proyecto:historialUs' x.idSprint.idProyecto.id x.idUs.id 0 volver x.idSprint.id %}"
                                           role="button">Ver historial</a>
                                    </div>
                                </div>
                            </div>
                        {% endif %}
                    {% endfor %}
                </div>
            </div>
        </div>

        <button style="display: none;" type="button" class="btn btn-primary" data-toggle="modal"
                data-target="#exampleModalCenter" id="botonAprobado">
            Menu Desplegable
        </button>

        <!-- Modal -->
        <div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog"
             aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Aprobador User Story</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <h6> Ingrese la fecha en que se aprueba el US: </h6>
                        <input type="date" name="fechaAprobado" class="dateinput form-control" id="datePicker"/>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
                        <button id="btnAprobarUs" type="button" class="btn btn-primary" onclick="btnAprobarUS()">Aprobar</button>
                    </div>
                </div>
            </div>
        </div>

    </div>

    <script>

        var data;

        function btnAprobarUS() {
            var fecha=document.getElementById('datePicker').value;
            post({
                planningPoker: document.getElementById(data).id,
                fecha: fecha,
                estado: "A",
                csrfmiddlewaretoken: '{{ csrf_token }}'
            });
        }

        //para hacer post al soltar y poder cambiar el estado

        function post(params) {

            // The rest of this code assumes you are not using a library.
            // It can be made less verbose if you use one.
            const form = document.createElement('form');
            form.method = "POST";
            form.action = "";

            for (const key in params) {
                if (params.hasOwnProperty(key)) {
                    const hiddenField = document.createElement('input');
                    hiddenField.type = 'hidden';
                    hiddenField.name = key;
                    hiddenField.value = params[key];

                    form.appendChild(hiddenField);
                }
            }

            document.body.appendChild(form);
            form.submit();
        }

        //Para evitar el re-envio de formulario

        if (window.history.replaceState) { // verificamos disponibilidad
            window.history.replaceState(null, null, window.location.href);
        }

        //Para poder agarrar y soltar

        function allowDrop(ev) {
            ev.preventDefault();
        }

        function drag(ev) {
            ev.dataTransfer.setData("text", ev.target.id);
        }

        function drop(ev) {
            ev.preventDefault();
            data = ev.dataTransfer.getData("text");
            //ev.currentTarget.firstElementChild.appendChild(document.getElementById(data));
            if (ev.currentTarget.firstElementChild.id === "divPendiente") {
                post({
                    planningPoker: document.getElementById(data).id,
                    estado: "P",
                    csrfmiddlewaretoken: '{{ csrf_token }}'
                });
            }
            if (ev.currentTarget.firstElementChild.id === "divProceso") {
                post({
                    planningPoker: document.getElementById(data).id,
                    estado: "EP",
                    csrfmiddlewaretoken: '{{ csrf_token }}'
                });
            }
            if (ev.currentTarget.firstElementChild.id === "divHecho") {
                post({
                    planningPoker: document.getElementById(data).id,
                    estado: "H",
                    csrfmiddlewaretoken: '{{ csrf_token }}'
                });
            }
            if (ev.currentTarget.firstElementChild.id === "divAprobado") {
                //Para setear la fecha de aprobacion del US
                document.getElementById('datePicker').valueAsDate = new Date();
                var button = document.getElementById("botonAprobado");
                button.click();
            }
        }

        document.addEventListener("DOMContentLoaded", function () {

            //para hacer los titulos del mismo tamaño

            var divPen = document.getElementById("divPendiente");
            var divPro = document.getElementById("divProceso");
            var divHec = document.getElementById("divHecho");
            var divApro = document.getElementById("divAprobado");
            var altura1 = divPen.clientHeight;
            var altura2 = divPro.clientHeight;
            var altura3 = divHec.clientHeight;
            var altura4 = divApro.clientHeight;
            if (altura4 >= altura1 && altura4 >= altura2 && altura4 >= altura3) {
                divPen.style.height = altura4;
                divHec.style.height = altura4;
                divPro.style.height = altura4;
            }
            if (altura3 >= altura1 && altura3 >= altura2 && altura3 >= altura4) {
                divPen.style.height = altura3;
                divPro.style.height = altura3;
                divApro.style.height = altura3;
            }
            if (altura2 >= altura1 && altura2 >= altura3 && altura2 >= altura4) {
                divPen.style.height = altura2;
                divHec.style.height = altura2;
                divApro.style.height = altura2;
            }
            if (altura1 >= altura2 && altura1 >= altura3 && altura1 >= altura4) {
                divPro.style.height = altura1;
                divHec.style.height = altura1;
                divApro.style.height = altura1;
            }

            // para hacer la franja contenedora de los us del mismo tamaño

            var divPenCards = document.getElementById("divPendienteCards");
            var divProCards = document.getElementById("divProcesoCards");
            var divHecCards = document.getElementById("divHechoCards");
            var divAproCards = document.getElementById("divAprobadoCards");
            var altCards1 = divPenCards.clientHeight;
            var altCards2 = divProCards.clientHeight;
            var altCards3 = divHecCards.clientHeight;
            var altCards4 = divAproCards.clientHeight;
            if (altCards4 >= altCards1 && altCards4 >= altCards2 && altCards4 >= altCards3) {
                divPenCards.style.height = altCards4;
                divProCards.style.height = altCards4;
                divHecCards.style.height = altCards4;
                divAproCards.style.height = altCards4;
            }
            if (altCards3 >= altCards1 && altCards3 >= altCards2 && altCards3 >= altCards4) {
                divPenCards.style.height = altCards3;
                divProCards.style.height = altCards3;
                divHecCards.style.height = altCards3;
                divAproCards.style.height = altCards3;
            }
            if (altCards2 >= altCards1 && altCards2 >= altCards3 && altCards2 >= altCards4) {
                divPenCards.style.height = altCards2;
                divProCards.style.height = altCards2;
                divHecCards.style.height = altCards2;
                divAproCards.style.height = altCards2;
            }
            if (altCards1 >= altCards2 && altCards1 >= altCards3 && altCards1 >= altCards4) {
                divPenCards.style.height = altCards1;
                divProCards.style.height = altCards1;
                divHecCards.style.height = altCards1;
                divAproCards.style.height = altCards1;
            }

        });

    </script>

{% endblock %}
